#!/bin/bash
#contact.sh version 1.0
#searches the pooter vCards and calls  helper sed and awk proceedures
#link this script to somewhere in your $PATH eg ~/bin/contact
#edit the two variables at top of file
#you must also edit sed2.txt using /home/user rather than ~/
#Copyright (C) 2006 David Matthews dmatthews@mailc.net; license at EOF

#PROG is the directory where this file and the other program scripts are stored
PROG=/home/david/.pooter/scripts
#DATA is the path to the vCard file
DATA=/home/david/.pooter/vCard

if [ ! -d $PROG ] || [ ! -f $DATA ]
	then
	echo;echo "You must edit the contact.sh and sed2.txt files to suit your system"
	echo;exit -1
fi

#__________no editing below here____________________________________________________

menu(){
	echo -e "\033[34m" #get blue font
	select NAME in "Get record" "Quit"
	do
		case $NAME in
			"Get record")
				#cancel blue font
				echo -e "enter the record number\033[0m"
				read RECORD 
				#get bold font
				echo -e "\033[1m" 
		        	$PROG/contact.awk -v record=$RECORD $PROG/contact.txt 
				menu
			;;
			"Quit")
				exit 0
			;;
		esac
	done
	echo
}
#__________________________________________________________________________________

usage(){
	echo
	echo "USAGE: `basename "$0 "` <arguments> either none, or a name as search string" 
	echo
	echo "`basename "$0 "` searches the vCard file for matching contact name" 
	echo "or with no arguments it presents a numbered list to select from"
	echo
	exit 0
}
#___________________________________________________________________________________

#search argument on command line
if [ "$1" != "" ]	;then
	if [ "$1" == "-h" ] || [ "$1" == "--help" ]
		then
		usage
	fi
	echo -e "\033[1m"
	#*run sed commands in file sed1 and sed2 to produce contacts file
	sed -f $PROG/sed1.txt $DATA | sed -f $PROG/sed2.txt -n 
	#use awk to extract the names from this
	awk -F+ '{print $1}' $PROG/contact.txt > $PROG/name.txt
	#write space seperated list of record numbers that match to a variable
	#-F sets field seperator, /search pattern/ is the command line argument
	RECORD=`awk -F+ "/$1/ {print NR}" $PROG/name.txt`
	
	#if record length is greater than 2 there is more than one match
	if [ ${#RECORD} -gt 2 ]		;then
	#extract number of first matching record		
	RECORD=${RECORD:0:2}
		echo "There are other matches, refine your search with surname\;firstname"
		echo "Or search record numbers by running this script without an argument"
		echo -e "\033[1m"
	fi
	#pass record number to awk script for formatted printout
	$PROG/contact.awk -v record=$RECORD $PROG/contact.txt
	echo;exit 0
#__________________________________________________________________________________

#no search argument
else 
	PS3="Select:- "	
	#as * (above), then run some awk commands from a file
	#use the column utility to output the result
	sed -f $PROG/sed1.txt $DATA |sed -f $PROG/sed2.txt | awk -F+ -f $PROG/awk.txt | column -x  
	menu
fi
#_____________________________________________________________________________________

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
