#!/bin/bash
#today.sh version 1.0
#searches the pooter calendar.xml file and outputs entries that match the date
#it calls the sed3.txt command file 
#today.sh -h | --help for more info
#link this script to somewhere in your $PATH eg ~/bin/today
#edit the two variables at top of file
#Copyright (C) 2006 David Matthews dmatthews@mailc.net; license at EOF

#PROG is the directory where this file and the other program scripts are stored
PROG=/home/david/.pooter/scripts/
#DATA is the path to the vCard file
DATA=/home/david/.pooter/calendar.xml

if [ ! -d $PROG ] || [ ! -f $DATA ]
	then
	echo;echo "You must edit the today.sh script to suit your system"
	echo;exit -1
fi

#__________no editing below here____________________________________________________

#deal with single day entries
today(){
	#select 30 lines after match (should be plenty!)
	#drop lines with </appointment> tag
	#stop when we get to </date> tag
	#we already have $TODAY, so drop lines with <date> tag
	#delete the > character
	#restore £ symbol
	#call a sed commands file to join line pairs with <appointment time / value 


	grep -A 30 $TODAY $DATA | grep -v '</appointment>' | sed /'<\/date>'/q | grep -v 'date'	| sed s/'>'// | sed s/'&#163;'/'£'/ | sed -f $PROG"sed3.txt" > $PROG"today.txt" 
	#we have a nice " field delimited file for awk
	awk -F\" '{print $2, "    ", $3}' $PROG/today.txt
}
#___________________________________________________________________________________
#deal with recurring entries
recur(){
	grep -A 10 $RECUR $DATA | grep -v 'appointment' | sed /'<\/date>'/q | grep -v 'date'	| sed s/'&#163;'/£/ 
	
}
#___________________________________________________________________________________
usage(){
	echo
	echo "USAGE: `basename "$0 "` <arguments> none, day as ** or day/month as **/**"
	echo
	echo "`basename "$0 "` searches the calendar.xml file for appointments" 
	echo "with no arguments it checks appointments for the current day"
	echo "with a day argument (eg 07), it checks that day of current month"
	echo "with a day/month argument (eg 17/03), it checks that date in current year"
	echo "with a day/month/year argument (eg 17/03/1952) ....."
	echo
	exit 0
}
#___________________________________________________________________________________

#get date in same format as calendar.xml
if [ "$1" != "" ]		;then
	TODAY=$1
	if [ "$TODAY" == "-h" ] || [ "$TODAY" == "--help" ]
		then
		usage
	elif [ ${#TODAY} == 2 ]		;then
		TODAY=$TODAY`date +/%m/%Y`
	elif [ ${#TODAY} == 5 ]		;then
		TODAY=$TODAY`date +/%Y`
	fi	
else
	TODAY=`date +%d/%m/%Y`
fi
RECUR=${TODAY:0:6}0000

echo;echo -e "\033[1m"$TODAY
recur
today
echo
#_____________________________________________________________________________________

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

